package bank.server;

import imaginary.persist.LockException;
import imaginary.persist.RemoteLockHolder;
import imaginary.persist.RemotePersistent;
import java.rmi.RemoteException;

public interface RemoteAccount extends RemotePersistent {
    public abstract float getBalance() throws RemoteException;
    
    public abstract RemoteCustomer getCustomer() throws RemoteException;
    
    public abstract int getCustomerId() throws RemoteException;
    
    public abstract String getAccountType() throws RemoteException;
    
    public abstract void deposit(RemoteLockHolder h, float amount)
    throws AccountException, LockException, RemoteException;

    public abstract void transfer(RemoteLockHolder h, float amount,
                                  RemoteAccount acct) throws AccountException,
                                                             LockException,
                                                             RemoteException;

    public void withdraw(RemoteLockHolder h, float amount)
    throws AccountException, LockException, RemoteException;
}
